// Copyright PingCAP, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/pingcap/tidb-operator/pkg/apis/pingcap/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeTidbInitializers implements TidbInitializerInterface
type FakeTidbInitializers struct {
	Fake *FakePingcapV1alpha1
	ns   string
}

var tidbinitializersResource = schema.GroupVersionResource{Group: "pingcap.com", Version: "v1alpha1", Resource: "tidbinitializers"}

var tidbinitializersKind = schema.GroupVersionKind{Group: "pingcap.com", Version: "v1alpha1", Kind: "TidbInitializer"}

// Get takes name of the tidbInitializer, and returns the corresponding tidbInitializer object, and an error if there is any.
func (c *FakeTidbInitializers) Get(name string, options v1.GetOptions) (result *v1alpha1.TidbInitializer, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(tidbinitializersResource, c.ns, name), &v1alpha1.TidbInitializer{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbInitializer), err
}

// List takes label and field selectors, and returns the list of TidbInitializers that match those selectors.
func (c *FakeTidbInitializers) List(opts v1.ListOptions) (result *v1alpha1.TidbInitializerList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(tidbinitializersResource, tidbinitializersKind, c.ns, opts), &v1alpha1.TidbInitializerList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.TidbInitializerList{ListMeta: obj.(*v1alpha1.TidbInitializerList).ListMeta}
	for _, item := range obj.(*v1alpha1.TidbInitializerList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested tidbInitializers.
func (c *FakeTidbInitializers) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(tidbinitializersResource, c.ns, opts))

}

// Create takes the representation of a tidbInitializer and creates it.  Returns the server's representation of the tidbInitializer, and an error, if there is any.
func (c *FakeTidbInitializers) Create(tidbInitializer *v1alpha1.TidbInitializer) (result *v1alpha1.TidbInitializer, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(tidbinitializersResource, c.ns, tidbInitializer), &v1alpha1.TidbInitializer{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbInitializer), err
}

// Update takes the representation of a tidbInitializer and updates it. Returns the server's representation of the tidbInitializer, and an error, if there is any.
func (c *FakeTidbInitializers) Update(tidbInitializer *v1alpha1.TidbInitializer) (result *v1alpha1.TidbInitializer, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(tidbinitializersResource, c.ns, tidbInitializer), &v1alpha1.TidbInitializer{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbInitializer), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeTidbInitializers) UpdateStatus(tidbInitializer *v1alpha1.TidbInitializer) (*v1alpha1.TidbInitializer, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(tidbinitializersResource, "status", c.ns, tidbInitializer), &v1alpha1.TidbInitializer{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbInitializer), err
}

// Delete takes name of the tidbInitializer and deletes it. Returns an error if one occurs.
func (c *FakeTidbInitializers) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(tidbinitializersResource, c.ns, name), &v1alpha1.TidbInitializer{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeTidbInitializers) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(tidbinitializersResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.TidbInitializerList{})
	return err
}

// Patch applies the patch and returns the patched tidbInitializer.
func (c *FakeTidbInitializers) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.TidbInitializer, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(tidbinitializersResource, c.ns, name, pt, data, subresources...), &v1alpha1.TidbInitializer{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.TidbInitializer), err
}
