// Copyright PingCAP, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "github.com/pingcap/tidb-operator/pkg/apis/pingcap/v1alpha1"
	scheme "github.com/pingcap/tidb-operator/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// TidbMonitorsGetter has a method to return a TidbMonitorInterface.
// A group's client should implement this interface.
type TidbMonitorsGetter interface {
	TidbMonitors(namespace string) TidbMonitorInterface
}

// TidbMonitorInterface has methods to work with TidbMonitor resources.
type TidbMonitorInterface interface {
	Create(*v1alpha1.TidbMonitor) (*v1alpha1.TidbMonitor, error)
	Update(*v1alpha1.TidbMonitor) (*v1alpha1.TidbMonitor, error)
	UpdateStatus(*v1alpha1.TidbMonitor) (*v1alpha1.TidbMonitor, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.TidbMonitor, error)
	List(opts v1.ListOptions) (*v1alpha1.TidbMonitorList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.TidbMonitor, err error)
	TidbMonitorExpansion
}

// tidbMonitors implements TidbMonitorInterface
type tidbMonitors struct {
	client rest.Interface
	ns     string
}

// newTidbMonitors returns a TidbMonitors
func newTidbMonitors(c *PingcapV1alpha1Client, namespace string) *tidbMonitors {
	return &tidbMonitors{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the tidbMonitor, and returns the corresponding tidbMonitor object, and an error if there is any.
func (c *tidbMonitors) Get(name string, options v1.GetOptions) (result *v1alpha1.TidbMonitor, err error) {
	result = &v1alpha1.TidbMonitor{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("tidbmonitors").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of TidbMonitors that match those selectors.
func (c *tidbMonitors) List(opts v1.ListOptions) (result *v1alpha1.TidbMonitorList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.TidbMonitorList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("tidbmonitors").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested tidbMonitors.
func (c *tidbMonitors) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("tidbmonitors").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a tidbMonitor and creates it.  Returns the server's representation of the tidbMonitor, and an error, if there is any.
func (c *tidbMonitors) Create(tidbMonitor *v1alpha1.TidbMonitor) (result *v1alpha1.TidbMonitor, err error) {
	result = &v1alpha1.TidbMonitor{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("tidbmonitors").
		Body(tidbMonitor).
		Do().
		Into(result)
	return
}

// Update takes the representation of a tidbMonitor and updates it. Returns the server's representation of the tidbMonitor, and an error, if there is any.
func (c *tidbMonitors) Update(tidbMonitor *v1alpha1.TidbMonitor) (result *v1alpha1.TidbMonitor, err error) {
	result = &v1alpha1.TidbMonitor{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("tidbmonitors").
		Name(tidbMonitor.Name).
		Body(tidbMonitor).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *tidbMonitors) UpdateStatus(tidbMonitor *v1alpha1.TidbMonitor) (result *v1alpha1.TidbMonitor, err error) {
	result = &v1alpha1.TidbMonitor{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("tidbmonitors").
		Name(tidbMonitor.Name).
		SubResource("status").
		Body(tidbMonitor).
		Do().
		Into(result)
	return
}

// Delete takes name of the tidbMonitor and deletes it. Returns an error if one occurs.
func (c *tidbMonitors) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("tidbmonitors").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *tidbMonitors) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("tidbmonitors").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched tidbMonitor.
func (c *tidbMonitors) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.TidbMonitor, err error) {
	result = &v1alpha1.TidbMonitor{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("tidbmonitors").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
